
tree_init:      pusha
                mov     tree_total, 0
                lea     di, stree
                mov     cx, stree_size
                xor     ax, ax
                cld
                rep     stosb
                popa
                ret

tree_findmin:   mov     eax, -1
                mov     edi, eax

                xor     ebx, ebx

@@1:            cmp     tree_next[ebx*2], 0
                jne     @@2

                cmp     ebx, esi
                je      @@2

                cmp     eax, tree_count[ebx*4]
                jbe     @@2

                mov     eax, tree_count[ebx*4]
                mov     edi, ebx

                or      eax, eax
                jz      @@3

@@2:            inc     ebx
                cmp     ebx, tree_max
                jbe     @@1

@@3:            cmp     edi, -1

                ret

error:          int     29h
                mov     ax, 4c00h
                int     21h

tree_create:    pushad

                lea     di, dtree
                mov     cx, dtree_size
                xor     ax, ax
                cld
                rep     stosb

                mov     tree_max, 255

@@1:            mov     esi, -1
                call    tree_findmin
                jz      error
                mov     esi, edi
                call    tree_findmin
                jz      @@2

                inc     tree_max
                mov     ebx, tree_max

                mov     eax, tree_count[esi*4]
                add     eax, tree_count[edi*4]
                mov     tree_count[ebx*4], eax

                mov     tree_next[esi*2], bx
                mov     tree_next[edi*2], bx

                mov     tree_prev1[ebx*2], si
                mov     tree_prev2[ebx*2], di

                mov     tree_bit[esi], 0
                mov     tree_bit[edi], 1

                jmp     @@1

@@2:           ; int 3

                mov     ebx, tree_max
                mov     eax, tree_count[ebx*4]
                cmp     eax, tree_total
                mov     al, '$'
               ; jne     error

                popad
                ret

tree_getcode:   push    ebx

                xor     ebx, ebx
                mov     bl, al

                xor     eax, eax
                xor     cx, cx

@@2:            cmp     tree_next[ebx*2], 0
                je      @@1

                shl     eax, 1
                or      al, tree_bit[ebx]
                inc     cx

                movzx   ebx, tree_next[ebx*2]
                jmp     @@2

@@1:            pop     ebx
                ret

